---------------------------------------------------------------------------------------------------------
-- @Author: Mantrid -------------------------------------------------------------------------------------
---------------------------------------------------------------------------------------------------------
----- Please ask permission before using this script, or parts thereof, in your own project -------------
---------------------------------------------------------------------------------------------------------

local modDirectory = g_currentModDirectory or ""
local modName = g_currentModName or "Unknown"
local modEnvironment

source(g_currentModDirectory .. 'scripts/EngineStarter.lua')

local function load(mission)
	assert(g_engineStarter == nil)
	modEnvironment = EngineStarter:new(mission, g_i18n, modDirectory, modName)
	getfenv(0)["g_engineStarter"] = modEnvironment
end

local function unload()
    modEnvironment:delete()
    modEnvironment = nil
    getfenv(0)["g_engineStarter"] = nil
end

local function startMission(mission)
    modEnvironment:onMissionStart(mission)
end

function initMod()
    FSBaseMission.delete = Utils.appendedFunction(FSBaseMission.delete, unload)

    Mission00.load = Utils.prependedFunction(Mission00.load, load)
    Mission00.onStartMission = Utils.appendedFunction(Mission00.onStartMission, startMission)

    InGameMenuGameSettingsFrame.onFrameOpen = Utils.appendedFunction(InGameMenuGameSettingsFrame.onFrameOpen, EngineStarter.initGui)
	

	Drivable.onLeaveVehicle = Utils.prependedFunction(Drivable.onLeaveVehicle, EngineStarter.onLeaveVehicle_prepend)
	Motorized.onUpdateTick = Utils.prependedFunction(Motorized.onUpdateTick, EngineStarter.onUpdateTick_prepend)
	FSCareerMissionInfo.saveToXMLFile = Utils.appendedFunction(FSCareerMissionInfo.saveToXMLFile, EngineStarter.saveSettings) -- Settings are saved live, but we need to do it here too, since the old save directory (with our xml) is now a backup

	-- Motorized.getIsPowered = Utils.overwrittenFunction(Motorized.getIsPowered, EngineStarter.getIsPowered)
	-- Vehicle.addPoweredActionEvent = Utils.overwrittenFunction(Vehicle.addPoweredActionEvent, EngineStarter.addPoweredActionEvent)
end

initMod()